def eval(env: Map[String, Double]) (expr: Expr): Double = expr match {
   case Var(v) => env(v)    // Look up variable name in Map
   case Number(x) => x
   case BinOp("+", e1, e2) => eval(env)(e1) + eval(env)(e2)
   case BinOp("*", e1, e2) => eval(env)(e1) * eval(env)(e2)
   case UnOp("-", e) => - eval(env)(e)
   }


val g = Map("x" -> 7.0, "pi" -> 3.14159)

val e = BinOp("*", Var("pi"), UnOp("-", Var("x")))

